/**
 * @file CRTinit.c
 * Copyright 2012, 2013 MinGW.org project
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

/*
 * A dummy version of _CRT_INIT for MS compatibility. Programs, or more often
 * dlls, which use the static version of the MSVC run time are supposed to
 * call _CRT_INIT to initialize the run time library in DllMain. This does
 * not appear to be necessary when using crtdll or the dll versions of the
 * MSVC runtime, so the dummy call simply does nothing.
 *
 * This object file is included as a standard in the link process as provided
 * by the appropriate GCC frontend.
 * 
 * To use this object include the object file in your link command:
 * gcc -o foo.exe foo.o CRTinit.o
 */

void
_CRT_INIT ()
{
}
